#
# mksrc.awk, 10 Nov 13

BEGIN {
# Top-level non-terminal
	print "prog_grammar = \"\"\""
	printf("program -> ")
	}

function mk_nonterm(nt)
{
nt_line=""
while ((getline a_line < nt) > 0)
   {
   if (nt_line == "")
      nt_line="'" a_line "'"
   else
      nt_line=nt_line " | '" a_line "'"
   }
close(nt)

print nt "_1 -> " nt_line
split(nonterm[nt], nt_seqs, " ")
max_seq=1
for (s in nt_seqs)
   if (nt_seqs[s] > max_seq)
      max_seq=nt_seqs[s]

for (s=2; s <= max_seq; s++)
   print nt "_" s " -> " nt "_" s-1 " | " nt "_" s-1 " " nt "_1"
}

function print_line(line_str)
{
printf(" \\\n   %s", line_str)
}


# Skip blank lines
NF == 0 {
	next
	}

# Skip comments
$1 == "//" {
	next
	}

$1 == "!" {
	max_occur=$3
	if ($3 == "")
	   {
	   print_line($2 "_1")
	   max_occur=1
	   }
	else
	   print_line($2 "_" $3)
	nonterm[$2]=nonterm[$2] " " max_occur
	next
	}

	{
	gsub("'", "\\'", $0)
	print_line("'" $0 "'")
	next
	}

END {
	print ""
	for (nt in nonterm)
	   mk_nonterm(nt)
	print "\"\"\""
	}

